/*jslint plusplus:false,white:false,undef: false, rhino: true, onevar: true, evil: false */

/*
Title: Configuraes gerais

Arquivo:

i3geo/classesjs/classe_configura.js

Licenca:

GPL2

I3Geo Interface Integrada de Ferramentas de Geoprocessamento para Internet

Direitos Autorais Reservados (c) 2006 Ministrio do Meio Ambiente Brasil
Desenvolvedor: Edmar Moretti edmar.moretti@mma.gov.br

Este programa  software livre; voc pode redistribu-lo
e/ou modific-lo sob os termos da Licena Pblica Geral
GNU conforme publicada pela Free Software Foundation;
tanto a verso 2 da Licena.
Este programa  distribudo na expectativa de que seja til,
porm, SEM NENHUMA GARANTIA; nem mesmo a garantia implcita
de COMERCIABILIDADE OU ADEQUAO A UMA FINALIDADE ESPECFICA.
Consulte a Licena Pblica Geral do GNU para mais detalhes.
Voc deve ter recebido uma cpia da Licena Pblica Geral do
GNU junto com este programa; se no, escreva para a
Free Software Foundation, Inc., no endereo
59 Temple Street, Suite 330, Boston, MA 02111-1307 USA.
*/
if(typeof(i3GEO) === 'undefined'){
	i3GEO = [];
}
/*
Classe: i3GEO.configura

Configurao do i3geo

Define os parmetros variveis do i3geo. Vc pode alterar com esta classe a maioria dos parmetros que controlam
o funcionamento do i3geo.

Exemplo:

i3GEO.configura.embedLegenda = "nao"

i3GEO.configura.cursores.ff = "/imagens/cursores/identifica2.png"

i3GEO.configura.cursores.ie = "/imagens/cursores/identifica2.cur"

alert(i3GEO.configura.locaplic)
*/
i3GEO.configura = {
	/*
	Propriedade: grupoLayers
	
	Lista de grupos e seus respectivos layers, para montagem da rvore de camadas.
	
	Se essa propriedade estiver definida, as camadas sero agrupadas na rvore de camadas conforme os grupos definidos.

	Por exemplo
	i3GEO.configura.grupoLayers = [
		{nome:"Grupo 1",layers:["zee","estadosl"]},
		{nome:"Grupo 2",layers:["mundo"]}
	]
	
	Type:
	{JASON}
	
	Default:
	""
	*/
	grupoLayers: "",
	/*
	Propriedade: oMenuData

	Itens includos no menu suspenso. Define os parmetros para o gadget menu suspenso

	Exemplo:

	oMenuData:{

		menu:[

			{nome:$trad("s1"),id:"ajudas"}

 		],

		submenus:{

			"ajudas": [ 

			{ text: $trad("u1"), url: "http://www.softwarepublico.gov.br/spb/ver-comunidade?community_id=1444332" },

			{ text: $trad("u2"), url: "javascript:i3GEO.ajuda.abreDoc()" }

			]

		}

	}
	
	Tipo:
	{object}
	*/
	oMenuData:{
		menu:[
			{nome:$trad("s1"),id:"ajudaMenu"},	
			{nome:$trad("s2"),id:"analise"},
 			{nome:$trad("s3"),id:"janelas"},
 			{nome:$trad("s4"),id:"arquivos"},
 			{nome:$trad("d27"),id:"interface"}
 		],
		submenus:{
			"ajudaMenu": [ 
			{ id:"omenudataAjudamenu1",text: $trad("u1"), url: "http://www.softwarepublico.gov.br/spb/ver-comunidade?community_id=1444332", target:"_blank" },
			{ id:"omenudataAjudamenu2",text: $trad("u2"), url: "javascript:i3GEO.ajuda.abreDoc()" },
			{ id:"omenudataAjudamenu3",text: $trad("u3"), url: "http://pt.wikibooks.org/wiki/I3geo", target:"_blank" },
			{ id:"omenudataAjudamenu4",text: $trad("u4"), url: "http://mapas.mma.gov.br/wikibooki3geo", target:"_blank" },
			{ id:"omenudataAjudamenu5",text: $trad("u5a"), url: "http://www.softwarepublico.gov.br", target:"_blank" },
			{ id:"omenudataAjudamenu6",text: "i3Geo Blog", url: "http://sistemas.mma.gov.br/blogs/index.php?blog=6", target:"_blank" },
			{ id:"omenudataAjudamenu7",text: "Lista de funes", url:"http://mapas.mma.gov.br/i3geo/ajuda_usuario.php", target:"_blank" }
			],
			"analise": [
    		{ id:"omenudataAnalise1",text: '<span style=color:gray;text-decoration:underline; ><b>'+$trad("u22")+'</b></span>',url: "#"}, 
			{ id:"omenudataAnalise2",text: $trad("u7"), url: "javascript:i3GEO.analise.dialogo.gradePol()"},
			{ id:"omenudataAnalise3",text: $trad("u8"), url: "javascript:i3GEO.analise.dialogo.gradePontos()" },
			{ id:"omenudataAnalise4",text: $trad("u9"), url: "javascript:i3GEO.analise.dialogo.gradeHex()" },
    		{ id:"omenudataAnalise5",text: '<span style=color:gray;text-decoration:underline; ><b>'+$trad("u23")+'</b></span>',url: "#"}, 
			{ id:"omenudataAnalise6",text: $trad("u11a"), url: "javascript:i3GEO.analise.dialogo.distanciaptpt()" },
			{ id:"omenudataAnalise7",text: $trad("u12"), url: "javascript:i3GEO.analise.dialogo.nptPol()" },
			{ id:"omenudataAnalise8",text: $trad("u13"), url: "javascript:i3GEO.analise.dialogo.pontoempoligono()" },
			{ id:"omenudataAnalise9",text: $trad("u14"), url: "javascript:i3GEO.analise.dialogo.pontosdistri()" },
    		{ id:"omenudataAnalise10",text: '<span style=color:gray;text-decoration:underline; ><b>'+$trad("u24")+'</b></span>',url: "#"}, 
			{ id:"omenudataAnalise11",text: $trad("u25"), url: "javascript:i3GEO.analise.dialogo.dissolve()" },
    		{ id:"omenudataAnalise12",text: '<span style=color:gray;text-decoration:underline; ><b>'+$trad("u27")+'</b></span>',url: "#"}, 
			{ id:"omenudataAnalise13",text: $trad("u6"), url: "javascript:i3GEO.analise.dialogo.analisaGeometrias()" },
			{ id:"omenudataAnalise14",text: $trad("u10"), url: "javascript:i3GEO.analise.dialogo.buffer()" },
			{ id:"omenudataAnalise15",text: $trad("u26"), url: "javascript:i3GEO.analise.dialogo.agrupaElementos()" },
			{ id:"omenudataAnalise16",text: $trad("u11"), url: "javascript:i3GEO.analise.dialogo.centroide()" },
			{ id:"omenudataAnalise17",text: $trad("t37"), url: "javascript:i3GEO.analise.dialogo.graficoInterativo()" }
			],
			"janelas": [
			{ id:"omenudataJanelas1",text: $trad("u15"), url: "javascript:initJanelaZoom('1');initJanelaZoom('2')" },
			{ id:"omenudataJanelas2",text: $trad("u16"), url: "javascript:i3GEO.ajuda.abreJanela()" }        
			],
			"arquivos": [
			{ id:"omenudataArquivos1",text: $trad("u17"), url: "javascript:i3GEO.mapa.dialogo.salvaMapa()" },
			{ id:"omenudataArquivos2",text: $trad("u18"), url: "javascript:i3GEO.mapa.dialogo.carregaMapa()" },
			{ id:"omenudataArquivos3",text: $trad("u19"), url: "javascript:i3GEO.gadgets.quadros.listaImagens()" },
			{ id:"omenudataArquivos4",text: $trad("u20"), url: "javascript:i3GEO.mapa.dialogo.convertews()" },
			{ id:"omenudataArquivos5",text: $trad("u20a"), url: "javascript:i3GEO.mapa.dialogo.convertekml()" },
			{ id:"omenudataArquivos6",text: $trad("u21"), url: "../geradordelinks.htm" }
			],
			"interface": [
			{ id:"omenudataInterface1",text: "Normal", url: "javascript:window.location = i3GEO.configura.locaplic+'/aplicmap/geral.htm?'+i3GEO.configura.sid" },
			{ id:"omenudataInterface2",text: "OpenLayers", url: "javascript:window.location = i3GEO.configura.locaplic+'/aplicmap/openlayers.htm?'+i3GEO.configura.sid" },
			{ id:"omenudataInterface3",text: "Flash", url: "javascript:window.location = i3GEO.configura.locaplic+'/aplicmap/flamingo.htm?'+i3GEO.configura.sid" },
			{ id:"omenudataInterface4",text: "Google Maps", url: "javascript:window.location = i3GEO.configura.locaplic+'/aplicmap/googlemaps.phtml?'+i3GEO.configura.sid" },
			{ id:"omenudataInterface5",text: "Google Earth", url: "javascript:window.location = i3GEO.configura.locaplic+'/aplicmap/googleearth.phtml?'+i3GEO.configura.sid" }
			]
		}
	},
	/*
	Propriedade: tipoimagem

	Indica o tipo de filtro de imagem que est ativo.
	O filtro ativo  aplicado sobre a imagem toda a vez que o mapa  refeito.
	
	Veja <classe_imagem.php> para obter os tipos possveis
	
	Tipo:
	{string}
	
	Default:
	{"nenhum"}
	*/
	tipoimagem: "nenhum",
	/*
	Propriedade: tipotip
	
	Tipo de tip que  mostrado na funo de identificao quando o usurio estaciona o mouse sobre o mapa
	
	Tipo:
	{string}
	
	Valores:
	
	completo|simples|balao
	
	Default:
	{"balao"}
	*/
	tipotip: "balao",
	/*
	Propriedade: funcaoTip
	
	Funo que ser executada na operao de identificao quando o usurio estaciona o mouse sobre o mapa
	
	Tipo:
	{String}
	
	Default:
	{"i3GEO.mapa.dialogo.verificaTipDefault()"}
	*/
	funcaoTip: "i3GEO.mapa.dialogo.verificaTipDefault()",
	/*
	Propriedade: funcaoIdentifica
	
	Funo que ser executada na operao de identificao quando o usurio clica no mapa
	
	Tipo:
	{String}
	
	Default:
	{"i3GEO.mapa.dialogo.cliqueIdentificaDefault()"}
	*/
	funcaoIdentifica: "i3GEO.mapa.dialogo.cliqueIdentificaDefault()",
	/*
	Propriedade: diminuixM

	Diminui a largura do mapa em pixels no caso do navegador ser o IE.
	Valores definidos em pixel.
	
	Tipo:
	{numeric}
	
	Default:
	{13}
	*/
	diminuixM: 13,
	/*
	Propriedade: diminuixN

	Diminui a largura do mapa em pixels no caso do navegador ser o FF.
	Valores definidos em pixel.
	
	Tipo:
	{numeric}
	
	Default:
	{11}
	*/
	diminuixN: 18,
	/*
	Propriedade: diminuiyM

	Diminui a altura do mapa em pixels no caso do navegador ser o IE.
	Valores definidos em pixel.
	
	Tipo:
	{numeric}
	
	Default:
	{106}
	*/
	diminuiyM: 106,
	/*
	Propriedade: diminuiyN

	Diminui a altura do mapa em pixels no caso do navegador ser o FF.
	Valores definidos em pixel.
	
	Tipo:
	{numeric}
	
	Default:
	{103}
	*/
	diminuiyN: 103,
	/*
	Propriedade: map3d

	Varivel que define o nome do map_file que possu o layer para uso na funo 3d.
	Pode ser utilizado o caminho completo, se no, busca no diretrio aplicmap.

	O mapfile deve conter um layer para clculo dos valores de Z para compor o modelo do relevo
	sobre o qual o mapa ser desenhado.

	Por padro, o i3geo utiliza o mapfile aplicmpa/3dmap.map
	
	Tipo:
	{string}
	
	Default:
	{""}
	*/
	map3d: "",
	/*
	Propriedade: embedLegenda

	Indica se a legenda deve ser incluida no corpo do mapa.

	Tipo:
	{string}
	
	Valores:
	sim|nao
	
	Default:
	{nao}
	*/
	embedLegenda: "nao",
	/*
	Propriedade: templateLegenda

	Template HTML que ser utilizado na gerao da legenda HTML.

	A sintaxe utilizada na montagem do template  baseado na sintaxe do prprio Mapserver.
	O HTML pode ser armazenado em i3geo/aplicmap ou em um outro endereo no servidor.
	O template serve para definir o layout da legenda que  mostrada quando a guia legenda  ativada.
	Se for definido como "",  utilizado o template i3geo/aplicmap/legenda.htm.
	
	Tipo:
	{string}
	
	Default:
	{""}
	*/
	templateLegenda: "",
	/*
	Propriedade: mashuppar
	
	Define os parmetros que devem ser aplicados no modo mashup
	
	O modo mashup possibilita que o i3Geo seja embutido dentro de uma pgina HTML. Nesse
	caso, o mapa no  criado no modo convencional, que utiliza o programa i3geo/ms_criamapa.php
	A variavel mashuppar deve conter os parmetros que so utilizados pelo programa ms_criamapa
	
	Exemplo:
	
	i3GEO.configura.mashuppar = "&pontos=-54 -12&temasa=biomas&layers=biomas"
	
	Tipo:
	{string}
	
	Default:
	{""}
	*/
	mashuppar: "",
	/*
	Propriedade: sid
	
	Cdigo da seo aberta pelo i3Geo no servidor.
	
	O cdigo  gerado na inicializao do i3Geo pelo programa ms_criamapa.php
	
	Tipo:
	{String}
	*/
	sid: "",
	/*
	Propriedade: locaplic
	
	Localizao da instalao do i3geo (URI)
	
	Por default,  definida na inicializao do i3Geo

	Tipo:
	{string}
	*/
	locaplic: "",
	/*
	Propriedade: mapaRefDisplay
	
	Indica se o mapa de referncia dever ser aberto quando o i3Geo for inicializado.
	
	Tipo:
	{string}
	
	Default:
	{"block"}
	
	Valores:
	block|none
	*/
	mapaRefDisplay: "block",
	/*
	Propriedade: visual
	
	Tipo de visual que ser utilizado no mapa.
	
	A lista de visuais existentes  obtida na inicializao do i3geo.
	
	Veja o diretrio i3geo/imagens/visual

	Tipo:
	{String}
	
	Default:
	{default}
	*/
	visual: "default",
	/*
	Propriedade: cursores
	
	Imagens utilizadas para os cursores do mouse mostrados no mapa
	
	A manipulao dos cursores  feita com i3GEO.util.mudaCursor
	
	 possvel utilizar tambm um dos tipos default, pointer, crosshair, help, move, text

	Tipo:
	{JSON}
	*/
	cursores: {
		"identifica":
		{ff:"pointer",ie:"pointer"},
		"pan":
		{ff:"/imagens/cursores/pan.png",ie:"/imagens/cursores/pan.cur"},
		"area":
		{ff:"/imagens/cursores/area.png",ie:"crosshair"},
		"distancia":
		{ff:"/imagens/cursores/distancia.png",ie:"crosshair"},
		"zoom":
		{ff:"/imagens/cursores/zoom.png",ie:"/imagens/cursores/zoom.cur"},
		"contexto":
		{ff:"/imagens/cursores/contexto.png",ie:"/imagens/cursores/contexto.cur"},
		"identifica_contexto":
		{ff:"pointer",ie:"pointer"},
		"pan_contexto":
		{ff:"/imagens/cursores/pan_contexto.png",ie:"/imagens/cursores/pan_contexto.cur"},
		"zoom_contexto":
		{ff:"/imagens/cursores/zoom_contexto.png",ie:"/imagens/cursores/zoom_contexto.cur"}
	},
	/*
	Propriedade: listaDePropriedadesDoMapa
	
	Lista com as funes que so includas no item "Propriedades do mapa"	

	Tipo:
	{JSON}
	*/
	listaDePropriedadesDoMapa: {
		"propriedades": [
		{ text: "p2", url: "javascript:i3GEO.mapa.dialogo.tipoimagem()"},
		{ text: "p3", url: "javascript:i3GEO.mapa.dialogo.opcoesLegenda()"},
		{ text: "p4", url: "javascript:i3GEO.mapa.dialogo.opcoesEscala()"},
		{ text: "p5", url: "javascript:i3GEO.mapa.dialogo.tamanho()"},
		{ text: "p6", url: "javascript:i3GEO.navega.entorno.ativaDesativa()"},
		{ text: "p7", url: "javascript:i3GEO.mapa.ativaLogo()"},
		{ text: "p8", url: "javascript:i3GEO.mapa.dialogo.queryMap()"},
		{ text: "p9", url: "javascript:i3GEO.mapa.dialogo.corFundo()"},
		{ text: "p10", url: "javascript:i3GEO.mapa.dialogo.gradeCoord()"},
		{ text: "p11", url: "javascript:i3GEO.mapa.dialogo.template()"},
		{ text: "p12", url: "javascript:i3GEO.mapa.dialogo.autoredesenha()"}
		]
	},
	/*
	Propriedade: tempoAplicar
	
	Tempo em milisegundos que ser esperado at que o mapa seja desenhado automaticamente.
	
	Utilizado no boto Aplicar, quando o usurio liga/desliga ou adiciona umtema
	
	Tipo:
	{Numeric}
	
	Default:
	{4000}
	*/
	tempoAplicar: 4000,
	/*
	Propriedade: tempoMouseParado
	
	Tempo em milisegundos que ser esperado para detectar que o mouse est parado.
	
	Controla o lapso de tempo utilizado para disparar as funes que ocorrem quando o mouse est parado sobre o mapa
	
	Tipo:
	{Numeric}
	
	Default:
	{3500}
	*/
	tempoMouseParado: 2500,
	/*
	Propriedade: iniciaJanelaMensagens
	
	Inicia o i3geo com a janela de mensagens aberta ou fechada.
	
	Se o cookie g_janelaMen estiver definido, essa varivel no ter efeito

	Tipo:
	{Boolean}
	
	Default:
	{true}
	*/
	iniciaJanelaMensagens: true,
	/*
	Propriedade: mostraRosaDosVentos
	
	Mostra ou no a rosa dos ventos sob o mouse quando estiver parado.

	Tipo:
	{string}
	
	Valores:
	{sim|nao}
	
	Default:
	{"nao"}
	*/	
	mostraRosaDosVentos: "nao",
	/*
	Propriedade: liberaGuias
	
	Indica se as guias sero montadas em uma janela flutuante sobre o mapa
	
	Tipo:
	{string}
	
	Valores:
	{sim|nao}
	
	Default:
	{nao}
	*/
	liberaGuias: "nao",
	/*
	Propriedade: entorno
	
	Define se o entorno do mapa ser desenhado tambm
	
	O desenho do entorno permite a navegao no mapa no estilo "tiles"
	
	Tipo:
	{string}
	
	Valores:
	{sim|nao}
	
	Default:
	{"nao"}
	*/
	entorno: "nao",
	/*
	Propriedade: funcoesBotoes

	Objeto com a lista de funcionalidades que sero adicionadas aos botes existentes no mapa.

	Essa lista pode ser modificada antes da inicializao do mapa.

	As funcionalidades apenas so includas se o elemento HTML indicado em iddiv existir. Por isso, caso uma funo no seja desejada, basta excluir o div do HTML utilizado no mapa.

	Tipo:
	{JSON}

	*/
	funcoesBotoes: {
		"botoes": [
		{
			//Insere a opo de zoom anterior e posterior.
			iddiv:"historicozoom",
			tipo:"",
			dica:$trad("d1"),
			constroiconteudo:'i3GEO.gadgets.mostraHistoricoZoom()'
		},
		{
			//Ativa o boto que realiza a operao de zoom para a extenso total do mapa.
			iddiv:"zoomtot",
			tipo:"",
			dica:$trad("d2"),
			funcaoonclick:function(){
				if(i3GEO.Interface.ATUAL === "openlayers"){
					i3GEO.Interface.openlayers.zoom2ext(i3GEO.parametros.extentTotal);
					return;
				}
				i3GEO.navega.zoomExt(i3GEO.configura.locaplic,i3GEO.configura.sid,i3GEO.configura.tipoimagem,i3GEO.parametros.extentTotal);
				marcadorZoom = "";
			}
		},
		{
			//Ativa o boto que realiza a operao de zoom interativo.
			iddiv:"zoomli",
			tipo:"dinamico",
			dica:$trad("d3"),
			funcaoonclick:function(){
				var temp;
				temp = "zoom";
				if(i3GEO.Interface.ATIVAMENUCONTEXTO)
				{temp = "zoom_contexto";}
				i3GEO.util.mudaCursor(i3GEO.configura.cursores,temp,"img",i3GEO.configura.locaplic);
				g_operacao='navega';
				g_tipoacao='zoomli';
				i3GEO.barraDeBotoes.ativaIcone("zoomli");
				marcadorZoom = "";
				if(i3GEO.Interface.ATUAL==="openlayers"){
					OLpanel.activateControl(OLzoom);
					return;
				}
				if(!$i("i3geoboxZoom"))
				{i3GEO.navega.zoomBox.criaBox();}				
				if(i3GEO.eventos.MOUSEDOWN.toString().search("i3GEO.navega.zoomBox.inicia()") < 0)
				{i3GEO.eventos.MOUSEDOWN.push("i3GEO.navega.zoomBox.inicia()");}
				if(i3GEO.eventos.MOUSEUP.toString().search("i3GEO.navega.zoomBox.termina()") < 0)
				{i3GEO.eventos.MOUSEUP.push("i3GEO.navega.zoomBox.termina()");}
				i3GEO.barraDeBotoes.BOTAOPADRAO = "zoomli";
			}
		},
		{
			//Ativa o boto que realiza a operao de deslocamento (pan).
			iddiv:"pan",
			tipo:"dinamico",
			dica:$trad("d4"),
			funcaoonclick:function(){
				var temp;
				g_tipoacao='pan';
				g_operacao='navega';
				i3GEO.barraDeBotoes.ativaIcone("pan");
				i3GEO.barraDeBotoes.BOTAOPADRAO = "pan";
				if($i(i3GEO.Interface.IDMAPA)){
					$i(i3GEO.Interface.IDMAPA).title = "";
					temp = "pan";
					if(i3GEO.Interface.ATIVAMENUCONTEXTO)
					{temp = "pan_contexto";}
					i3GEO.util.mudaCursor(i3GEO.configura.cursores,temp,i3GEO.Interface.IDMAPA,i3GEO.configura.locaplic);
				}
				marcadorZoom = "";
				if(i3GEO.Interface.ATUAL==="openlayers"){
					OLpanel.activateControl(OLpan);
					return;
				}
				panMapaInicia = function(exy){
					var k;
					leftinicial = 0;
					topinicial = 0;
					if ($i("img") && (g_tipoacao === "pan")){
						try{
							if(arguments.length > 0){
								if(navm)
								{k = event.button;}
								else
								{k = exy.button;}
								if(k === 2){return;}
							}
						}
						catch(h){
							if(typeof(console) !== 'undefined'){console.error(h);}
						}
						g_panM = "sim";
						if($i(i3GEO.Interface.IDCORPO)){
							leftinicial = parseInt($i(i3GEO.Interface.IDCORPO).style.left,10);
							topinicial = parseInt($i(i3GEO.Interface.IDCORPO).style.top,10);
						}
						clicinicialx = objposicaocursor.imgx;
						clicinicialy = objposicaocursor.imgy;
						ddinicialx = objposicaocursor.ddx;
						ddinicialy = objposicaocursor.ddy;
						//
						//faz os clculos para o posicionamento do box sobre o mapa de referncia
						//
						boxrefObj = $i("boxref");
						if(boxrefObj){
							proporcaoBox = i3GEO.parametros.w / parseInt(boxrefObj.style.width,10);
							boxrefObjLeft = parseInt(boxrefObj.style.left,10);
							boxrefObjTop = parseInt(boxrefObj.style.top,10);
						}
					}
				};
				panMapaDesloca = function(){
					var nx,ny,l,t;
					if ($i(i3GEO.Interface.IDMAPA) && (g_panM === "sim")){
						nx = objposicaocursor.telax - leftinicial - clicinicialx;
						ny = objposicaocursor.telay - topinicial - clicinicialy;
						if (i3GEO.configura.entorno === "nao"){
							l = 0;
							if (parseInt($i("i3geo").style.left,10))
							{l = parseInt($i("i3geo").style.left,10);}
							$i(i3GEO.Interface.IDMAPA).style.left = nx - l;
							t = 0;
							if (parseInt($i("i3geo").style.top,10))
							{t = parseInt($i("i3geo").style.top,10);}
							$i(i3GEO.Interface.IDMAPA).style.top = ny - t;
							if(boxrefObj){
								boxrefObj.style.left = boxrefObjLeft - (nx / proporcaoBox);
								boxrefObj.style.top = boxrefObjTop - (ny / proporcaoBox);
							}
						}
						else{
							$left("img",i3GEO.parametros.w*-1 + nx);
							$left("imgS",i3GEO.parametros.w*-1 + nx);
							$left("imgL",i3GEO.parametros.w + nx);
							$left("imgO",i3GEO.parametros.w*-3 + nx);
							$left("imgN",i3GEO.parametros.w*-1 + nx);
							$top("img",i3GEO.parametros.h*-1 + ny);
							$top("imgS",i3GEO.parametros.h*-1 + ny);
							$top("imgL",i3GEO.parametros.h*-1 + ny);
							$top("imgN",i3GEO.parametros.h*-1 + ny);
							$top("imgO",i3GEO.parametros.h*-1 + ny);
						}
					}
				};
				panMapaTermina = function(){
					if (g_tipoacao === "pan"){
						marcadorZoom = "";
						g_panM = "nao";
						//alert(ddinicialx+","+ddinicialy+","+objposicaocursor.ddx+","+objposicaocursor.ddy)
						try{
							var f = "i3GEO.navega.timerNavega = null;if("+
								"i3GEO.navega.xy2xy('"+
									i3GEO.configura.locaplic+"','"+i3GEO.configura.sid+"',"+ddinicialx+","+ddinicialy+","+objposicaocursor.ddx+","+objposicaocursor.ddy+",'"+i3GEO.parametros.mapexten+"','"+i3GEO.configura.tipoimagem+"'"+
									") == false"+
								"){"+
									"i3GEO.navega.zoompontoIMG('"+i3GEO.configura.locaplic+"','"+i3GEO.configura.sid+"',"+objposicaocursor.imgx+","+objposicaocursor.imgy+")"+
								"}";
							clearTimeout(i3GEO.navega.timerNavega);
							i3GEO.navega.timerNavega = setTimeout(f,i3GEO.navega.TEMPONAVEGAR);
						}
						catch(e){
							if(typeof(console) !== 'undefined'){console.error(e);}
						}
					}
				};
				if(i3GEO.eventos.MOUSEDOWN.toString().search("panMapaInicia()") < 0)
				{i3GEO.eventos.MOUSEDOWN.push("panMapaInicia()");}
				if(i3GEO.eventos.MOUSEMOVE.toString().search("panMapaDesloca()") < 0)
				{i3GEO.eventos.MOUSEMOVE.push("panMapaDesloca()");}
				if(i3GEO.eventos.MOUSEUP.toString().search("panMapaTermina()") < 0)
				{i3GEO.eventos.MOUSEUP.push("panMapaTermina()");}
			}
		},
		{
			//boto que realiza a operao de zoom in.
			iddiv:"zoomiauto",
			tipo:"",
			dica:$trad("d5"),
			funcaoonclick:function(){
				i3GEO.navega.zoomin(i3GEO.configura.locaplic,i3GEO.configura.sid);
				marcadorZoom = '';
			}
		},
		{
			//boto que realiza a operao de zoom out
			iddiv:"zoomoauto",
			tipo:"",
			dica:$trad("d6"),
			funcaoonclick:function(){
				i3GEO.navega.zoomout(i3GEO.configura.locaplic,i3GEO.configura.sid);
				marcadorZoom = "";
			}
		},
		{
			//boto que abre a funo de identificao.
			iddiv:"identifica",
			tipo:"dinamico",
			dica:$trad("d7"),
			funcaoonclick:function()
			{
				var temp;
				if(i3GEO.Interface.ATUAL==="padrao"){
					$i("img").title = "";
					temp = "identifica";
					if(i3GEO.Interface.ATIVAMENUCONTEXTO)
					{temp = "identifica_contexto";}
					i3GEO.util.mudaCursor(i3GEO.configura.cursores,temp,"img",i3GEO.configura.locaplic);
				}
				i3GEO.barraDeBotoes.ativaIcone("identifica");
				g_tipoacao='identifica';
				g_operacao='identifica';
				i3GEO.barraDeBotoes.BOTAOPADRAO = "identifica";
				cliqueIdentifica = function(){
					if (g_operacao === "identifica"){
						eval(i3GEO.configura.funcaoIdentifica);
					}
				};
				if(i3GEO.eventos.MOUSECLIQUE.toString().search("cliqueIdentifica()") < 0)
				{i3GEO.eventos.MOUSECLIQUE.push("cliqueIdentifica()");}
				if(i3GEO.eventos.MOUSECLIQUE.toString().search("verificaTip()") > 0)
				{i3GEO.eventos.MOUSECLIQUE.remove("verificaTip()");}
				if(i3GEO.eventos.MOUSEPARADO.toString().search("verificaTip()") > 0)
				{i3GEO.eventos.MOUSEPARADO.remove("verificaTip()");}
			}
		},
		{
			//boto que abre a funo de identificao do tipo balao.
			iddiv:"identificaBalao",
			tipo:"dinamico",
			dica:$trad("d7a"),
			funcaoonclick:function()
			{
				var temp;
				if(i3GEO.Interface.ATUAL==="padrao"){
					$i("img").title = "";
					temp = "identifica";
					if(i3GEO.Interface.ATIVAMENUCONTEXTO)
					{temp = "identifica_contexto";}
					i3GEO.util.mudaCursor(i3GEO.configura.cursores,temp,"img",i3GEO.configura.locaplic);
				}
				i3GEO.barraDeBotoes.ativaIcone("identificaBalao");
				g_tipoacao='identifica';
				g_operacao='identifica';
				i3GEO.barraDeBotoes.BOTAOPADRAO = "identificaBalao";
				verificaTip = function(){
					if(g_operacao !== "identifica" || i3GEOF.identifica){return;}
					if($i("marcaIdentifica")){return;}
					//funcao default para pegar os dados
					if (g_operacao === "identifica"){
						eval(i3GEO.configura.funcaoTip);
					}
				};
				if(i3GEO.eventos.MOUSECLIQUE.toString().search("cliqueIdentifica()") > 0)
				{i3GEO.eventos.MOUSECLIQUE.remove("cliqueIdentifica()");}				
				if(i3GEO.eventos.MOUSECLIQUE.toString().search("verificaTip()") < 0)
				{i3GEO.eventos.MOUSECLIQUE.push("verificaTip()");}
				if(i3GEO.eventos.MOUSEPARADO.toString().search("verificaTip()") < 0)
				{i3GEO.eventos.MOUSEPARADO.push("verificaTip()");}
			}
		},
		{
			//boto que abre a janela com o valor da extenso geogrfica do mapa atual
			iddiv:"exten",
			tipo:"",
			dica:$trad("d8"),
			funcaoonclick:function(){
				if(typeof(i3GEOF.mostraExten) === 'undefined'){
					var js = i3GEO.configura.locaplic+"/ferramentas/mostraexten/index.js.php";
					i3GEO.util.scriptTag(js,"i3GEOF.mostraExten.criaJanelaFlutuante()","i3GEOF.mostraExten_script");
				}			
			}
		},
		{
			//boto que abre a janela com o mapa de referncia
			iddiv:"referencia",
			tipo:"",
			dica:$trad("d9"),
			funcaoonclick:function()
			{i3GEO.maparef.inicia();}
		},
		{
			//boto de busca na wikipedia
			iddiv:"wiki",
			tipo:"",
			dica:$trad("d11"),
			funcaoonclick:function(){
				if(typeof(i3GEOF.wiki) === 'undefined'){
					var js = i3GEO.configura.locaplic+"/ferramentas/wiki/index.js.php";
					i3GEO.util.scriptTag(js,"i3GEOF.wiki.criaJanelaFlutuante()","i3GEOF.wiki_script");
				}
			}
		},
		{
			//boto de busca na rede metar
			iddiv:"metar",
			tipo:"",
			dica:$trad("d29"),
			funcaoonclick:function(){
				if(typeof(i3GEOF.metar) === 'undefined'){
					var js = i3GEO.configura.locaplic+"/ferramentas/metar/index.js.php";
					i3GEO.util.scriptTag(js,"i3GEOF.metar.criaJanelaFlutuante()","i3GEOF.metar_script");
				}
			}
		},
		{
			//boto de busca de fotos
			iddiv:"buscafotos",
			tipo:"",
			dica:"Fotos",
			funcaoonclick:function(){
				if(typeof(i3GEOF.buscaFotos) === 'undefined'){
					var js = i3GEO.configura.locaplic+"/ferramentas/buscafotos/index.js.php";
					i3GEO.util.scriptTag(js,"i3GEOF.buscaFotos.criaJanelaFlutuante()","i3GEOF.buscaFotos_script");
				}
			}
		},
		{
			//boto de impresso
			iddiv:"imprimir",
			tipo:"",
			dica:$trad("d12"),
			funcaoonclick:function(){
				if(typeof(i3GEOF.imprimir) === 'undefined'){
					var js = i3GEO.configura.locaplic+"/ferramentas/imprimir/index.js.php";
					i3GEO.util.scriptTag(js,"i3GEOF.imprimir.criaJanelaFlutuante()","i3GEOF.imprimir_script");
				}			
			}
		},
		{
			//boto de localizao do usurio pelo IP
			iddiv:"ondeestou",
			tipo:"",
			dica:$trad("d13"),
			funcaoonclick:function()
			{i3GEO.navega.zoomIP(i3GEO.configura.locaplic,i3GEO.configura.sid);}
		},
		{
			//abre a opo de gerao de um modelo virtual de elevao
			iddiv:"v3d",
			tipo:"",
			dica:$trad("d14"),
			funcaoonclick:function(){
				if(typeof(i3GEOF.t3d) === 'undefined'){
					var js = i3GEO.configura.locaplic+"/ferramentas/3d/index.js.php";
					i3GEO.util.scriptTag(js,"i3GEOF.t3d.criaJanelaFlutuante()","i3GEOF.t3d_script");
				}
			}
		},
		{
			iddiv:"google",
			tipo:"",
			dica:$trad("d15"),
			funcaoonclick:function(){
				//isso no funciona
				/*
				if(typeof(i3GEOF.googlemaps) === 'undefined'){
					var js = i3GEO.configura.locaplic+"/ferramentas/googlemaps/index.js.php";
					i3GEO.util.scriptTag(js,"i3GEOF.googlemaps.criaJanelaFlutuante()","i3GEOF.googlemaps_script");
				}
				*/
				if(i3GEO.eventos.NAVEGAMAPA.toString().search("atualizagoogle()") > 0)
				{i3GEO.eventos.NAVEGAMAPA.remove("atualizagoogle()");}
				i3GEO.util.criaBox();
				g_operacao = "navega";
				var idgoogle = "googlemaps"+Math.random();
				if(navn){i3GEO.janela.cria((i3GEO.parametros.w/2)+25+"px",(i3GEO.parametros.h/2)+18+"px",i3GEO.configura.locaplic+"/ferramentas/googlemaps/index.php","","","Google maps <a class=ajuda_usuario target=_blank href='"+i3GEO.configura.locaplic+"/ajuda_usuario.php?idcategoria=7&idajuda=68' >&nbsp;&nbsp;&nbsp;</a>",idgoogle);}
				else
				{i3GEO.janela.cria("530px","330px",i3GEO.configura.locaplic+"/ferramentas/googlemaps/index.php","","","Google maps <a class=ajuda_usuario target=_blank href='"+i3GEO.configura.locaplic+"/ajuda_usuario.php?idcategoria=7&idajuda=68' >&nbsp;&nbsp;&nbsp;</a>",idgoogle);}
				atualizagoogle = function(){
					try{
						//window.parent.googlemaps.panTogoogle();
						parent.frames[idgoogle+"i"].panTogoogle();
					}
					catch(e){
						i3GEO.eventos.NAVEGAMAPA.remove("atualizagoogle()");
						if(typeof(console) !== 'undefined'){console.error(e);}
					}
				};
				if(i3GEO.eventos.NAVEGAMAPA.toString().search("atualizagoogle()") < 0)
				{i3GEO.eventos.NAVEGAMAPA.push("atualizagoogle()");}
				if(i3GEO.Interface.ATUAL === "openlayers"){
					i3geoOL.events.register("moveend",i3geoOL,function(e){
						try{window.parent.wdocai.panTogoogle();}
						catch(x){
							if(typeof(console) !== 'undefined'){console.error(x);}
						}
					});
				}
			}
		},
		{
			//Ativa o boto que realiza a operao de de busca no site Scielo
			iddiv:"scielo",
			tipo:"",
			dica:$trad("d16"),
			funcaoonclick:function(){
				scieloAtivo = false;//esta varivel  utilizada pela ferramenta durante a navegao no mapa. Se estiver true significa que a ferramenta est sendo atualizada durante um processo de navegao no mapa				
				g_operacao = "navega";
				i3GEO.janela.cria("450px","190px",i3GEO.configura.locaplic+"/ferramentas/scielo/index.htm","","","Scielo");
				atualizascielo = function(){
					var docel;
					try{
						docel = (navm) ? document.frames("wdocai").document : $i("wdocai").contentDocument;
						if (docel.getElementById("resultadoscielo"))
						{$i("wdocai").src = i3GEO.configura.locaplic+"/ferramentas/scielo/index.htm";}
						else{
							i3GEO.eventos.NAVEGAMAPA.remove("atualizascielo()");
							if(i3GEO.Interface.ATUAL === "googlemaps"){
								GEvent.removeListener(scieloDragend);
								GEvent.removeListener(scieloZoomend);
							}
						}
					}
					catch(e){scieloAtivo = false;i3GEO.eventos.NAVEGAMAPA.remove("atualizascielo()");}
				};
				if(i3GEO.eventos.NAVEGAMAPA.toString().search("atualizascielo()") < 0){
					i3GEO.eventos.NAVEGAMAPA.push("atualizascielo()");
					if(i3GEO.Interface.ATUAL === "googlemaps"){
   						scieloDragend = GEvent.addListener(i3GeoMap, "dragend", function() {atualizascielo();});
   						scieloZoomend = GEvent.addListener(i3GeoMap, "zoomend", function() {atualizascielo();});						
					}
					if(i3GEO.Interface.ATUAL === "openlayers"){
   						i3geoOL.events.register("moveend",i3geoOL,function(e){atualizascielo();});
					}
				}
			}
		},
		{
			//Ativa o boto que realiza a operao de de busca no site confluence
			iddiv:"confluence",
			tipo:"",
			dica:$trad("d17"),	
			funcaoonclick:function(){
				if(typeof(i3GEOF.confluence) === 'undefined'){
					var js = i3GEO.configura.locaplic+"/ferramentas/confluence/index.js.php";
					i3GEO.util.scriptTag(js,"i3GEOF.confluence.criaJanelaFlutuante()","i3GEOF.confluence_script");
				}
			}
		},
		{
			//Ativa o boto que abre a lente de aumento
			iddiv:"lentei",
			tipo:"",
			dica:$trad("d18"),
			funcaoonclick:function()
			{
				if (i3GEO.navega.lente.ESTAATIVA === "nao")
				{i3GEO.navega.lente.inicia();}
				else
				{i3GEO.navega.lente.desativa();}
			}
		},
		{
			//Coloca as guias em uma janela mvel
			iddiv:"encolheFerramentas",
			tipo:"",
			dica:$trad("d19"),
			funcaoonclick:function()
			{i3GEO.guias.libera();}
		},
		{
			//boto de reinicializao do mapa que restaura as condies iniciais do mapa
			iddiv:"reinicia",
			tipo:"",
			dica:$trad("d20"),
			funcaoonclick:function(){
				var buscarapida = $i("valorBuscaRapida");
				if(buscarapida){buscarapida.value="";}
				i3GEO.janela.abreAguarde("i3GEO.atualiza",$trad("o1"));
				i3GEO.arvoreDeCamadas.CAMADAS = "";
				i3GEO.contadorAtualiza++;
				i3GEO.php.reiniciaMapa(i3GEO.atualiza);
			}
		},
		{
			//boto de medio de distncias
			iddiv:"mede",
			tipo:"dinamico",
			dica:$trad("d21"),
			funcaoonclick:function(){
				i3GEO.barraDeBotoes.ativaIcone("mede");
				if($i(i3GEO.Interface.IDMAPA)){
					i3GEO.util.mudaCursor(i3GEO.configura.cursores,"distancia",i3GEO.Interface.IDMAPA,i3GEO.configura.locaplic);
				}
				g_tipoacao = "";
				g_operacao="";
				i3GEO.analise.medeDistancia.inicia();			}
		},
		{
			//boto de medio de rea
			iddiv:"area",
			tipo:"dinamico",
			dica:$trad("d21a"),
			funcaoonclick:function(){
				i3GEO.barraDeBotoes.ativaIcone("area");
				if($i("img")){
					$i("img").title = "";
					i3GEO.util.mudaCursor(i3GEO.configura.cursores,"area","img",i3GEO.configura.locaplic);
				}
				g_tipoacao = "";
				g_operacao="";
				i3GEO.analise.medeArea.inicia();
			}
		},
		{
			//boto de digitalizao
			iddiv:"inserexy",
			tipo:"dinamico",
			dica:$trad("d22"),
			funcaoonclick:function(){
				i3GEO.barraDeBotoes.ativaIcone("inserexy");
				g_tipoacao = "";
				i3GEO.mapa.dialogo.cliquePonto();
			}
		},
		{
			//boto de incluso de grficos
			iddiv:"inseregrafico",
			tipo:"dinamico",
			dica:$trad("d23"),
			funcaoonclick:function(){
				g_tipoacao = "";
				i3GEO.mapa.dialogo.cliqueGrafico();
				if($i("img")){
					$i("img").title = "clique para incluir o grfico";
					$i("img").style.cursor="pointer";
				}		
			}
		},
		{
			//boto de seleo
			iddiv:"selecao",
			tipo:"dinamico",
			dica:$trad("d24"),
			funcaoonclick:function(){
				i3GEO.barraDeBotoes.ativaIcone("selecao");
				i3GEO.mapa.dialogo.selecao();
			}
		},
		{
			//boto de insero de toponmia
			iddiv:"textofid",
			tipo:"dinamico",
			dica:$trad("d25"),
			funcaoonclick:function(){
				i3GEO.barraDeBotoes.ativaIcone("textofid");
				g_tipoacao = "";
				i3GEO.mapa.dialogo.cliqueTexto();
			}
		},
		{
			//monta rotas com o googlemaps
			iddiv:"rota",
			tipo:"",
			dica:"Rota",
			funcaoonclick:function(){
				if(i3GEO.Interface.ATUAL !== "googlemaps")
				{alert("Operacao disponivel apenas na interface Google Maps");return;}
   				counterClick = 1;
    			var parametrosRota = function(overlay,latlng){
    				var temp,janela;
    				if(counterClick === 1){	
    					counterClick++;
    					alert("Clique o ponto de destino da rota");
    					pontoRota1 = latlng;
    					return;
    				}
    				if(counterClick === 2){
    					pontoRota2 = latlng;
    					counterClick = 0;
    					GEvent.removeListener(rotaEvento);
    					janela = i3GEO.janela.cria("300px","300px","","center","","Rota");
    					janela[2].style.overflow = "auto";
    					janela[2].style.height = "300px";
						directions = new GDirections(i3GeoMap,janela[2]);
						temp = function(){
							$i("wdoca_corpo").innerHTML = "No foi possvel criar a rota";
						};
						GEvent.addListener(directions, "error", temp);
						directions.load("from: "+pontoRota1.lat()+","+pontoRota1.lng()+" to: "+pontoRota2.lat()+","+pontoRota2.lng());
    					//i3GeoMap.removeOverlay(directions)
    				}
    			};
   				rotaEvento = GEvent.addListener(i3GeoMap, "click", parametrosRota);
   				alert("Clique o ponto de origem da rota");
			}
		}
	]}
};
//YAHOO.log("carregou classe configura", "Classes i3geo");