<?php
/*
Title: Variveis de inicializao ms_configura.php

Nesse programa PHP so definidas as variveis globais principais necessrias ao funcionamento do I3Geo do lado do servidor web.

O ms_configura  includo em vrios programas do i3Geo e os valores das variveis devem ser editados 
caso a instalao do i3geo tenha sido feita em um diretrio diferente do padro.
No windows o diretrio padro  c:\ms4w\apache\htdocs\i3geo e no linux  /opt/www/html/i3geo

Para verificar a instalao do i3geo utilize o programa i3geo/testainstal.php, que pode fornecer algumas dicas
caso estejam ocorrendo problemas na iniciallizao.

As variveis de configurao so definidas em blocos diferentes conforme o sistema operacional (linux ou windows).

O ms_criamapa.php carrega o ms_configura.php e armazena a maior parte das variveis na seo. Algumas variveis
so tambm fornecidas para o cliente (navegador) na inicializao do mapa e ficam disponveis em variveis javascript.


Licenca:

GPL2

I3Geo Interface Integrada de Ferramentas de Geoprocessamento para Internet

Direitos Autorais Reservados (c) 2006 Ministrio do Meio Ambiente Brasil
Desenvolvedor: Edmar Moretti edmar.moretti@mma.gov.br

Este programa  software livre; voc pode redistribu-lo
e/ou modific-lo sob os termos da Licena Pblica Geral
GNU conforme publicada pela Free Software Foundation;
tanto a verso 2 da Licena.
Este programa  distribudo na expectativa de que seja til,
porm, SEM NENHUMA GARANTIA; nem mesmo a garantia implcita
de COMERCIABILIDADE OU ADEQUAO A UMA FINALIDADE ESPECFICA.
Consulte a Licena Pblica Geral do GNU para mais detalhes.
Voc deve ter recebido uma cpia da Licena Pblica Geral do
GNU junto com este programa; se no, escreva para a
Free Software Foundation, Inc., no endereo
59 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

Arquivo: ms_configura.php

*/
/*
	Variavel: mensagemInicia
	
	Mensagem de inicializao mostrada pelo programa ms_criamapa.php
	
	Tipo:
	{string}
*/
$mensagemInicia = 'Vers&atilde;o 4.3 - Revis&atilde;o SVN 1579';
/*
	Variable: tituloInstituicao
	
	Nome que ser utilizado em alguns cabealhos e ttulos de pginas
	
	Tipo:
	{string}
*/
$tituloInstituicao = "i3Geo";
/*
	Variable: googleApiKey
	
	Chave utilizada pela API do Google maps.
	
	A API do Google maps  utilizada em algumas funcionalidades do i3geo. Vc deve registrar uma chave
	no site do Google para o seu endereo de servidor web. veja como fazer em:
	http://code.google.com/apis/maps/signup.html
	
	Tipo:
	{string}
*/
$googleApiKey = "ABQIAAAAKguAlmd-hSDulF2T_tfWMxT3OAK09d_ZSDyC36iPGlww-4j-9xSrR2ZZUxVeZC01q8anfe5ntl_U4w";

if (strtoupper(substr(PHP_OS, 0, 3) == 'WIN'))
{
	/*
	Variable: navegadoresLocais
	
	Ip dos usuarios que podem navegar no servidor para acessar arquivos de dados geogrficos.
	
	O i3geo possibilita que os usurios acessem dados geogrficos no servidor diretamente, navegando pelo sistema de arquivos.
	Isso possibilita o acesso aos dados mesmo que no constem na rvore de temas definida em menutemas/menutemas.xml
	Por segurana, essa funcionalidade s  ativada para nmeros IP especficos, definidos nessa varivel.
	
	Para cada IP registrado, deve-se definir os diretrios que sero acessveis, conforme mostrado abaixo.
	
	A validao do IP  feita com javascript, na inicializao do mapa, a varivel javascript objmapa.navegacaoDir  definida como sim (caso $navegadoresLocais for diferente de "") ou nao.
	
	Se objmapa.navegacaoDir for igual a "sim", ou seja, $navegadoresLocais  diferente de "", na guia de adio de temas da interface HTML, ser mostrada a opo de navegao. Portanto, se vc no quiser que essa opo seja ativada, mantenha essa varivel igual a
	
	$navegadoresLocais = "";
	
	Com a opo ativa na interface do mapa, o ip do cliente  verificado e caso estiver registrado no array, a navegao pelos diretrios do servidor ser permitida. Para mais detalhes, veja a ferramenta i3geo/ferramentas/navegacaodir
	 
	Tipo:
	{array}
	*/
	
	$navegadoresLocais = array(
							array(
							"ip"=>"127.0.0.1",
							"drives"=>array(
										array("caminho"=>"c:/","nome"=>"c"),
										array("caminho"=>"d:/","nome"=>"d")
										)
							)
						);
	/*
	Variable: editores
	
	Ip dos usuarios que podem administrar o i3geo via navegador.
	
	Separe os ips por vrgula. Os usurios que tiverem seus ips listados, podero editar o diretrio i3geo/temas, desde que os mesmos tenham direito de leitura e escrita nesse diretrio.
	
	Tipo:
	{array}
	*/
	$editores = array("127.0.0.1","localhost");
	/*
	Variable: dir_tmp
	
	Caminho completo do diretrio temporrio utilizado pelo mapserver.
	
	Tipo:
	{string}
	*/
	$dir_tmp = "c:/ms4w/tmp/ms_tmp";
	/*
	Variable: locaplic
	
	Caminho completo onde fica o I3Geo
	
	Tipo:
	{string}
	*/
	$locaplic = "c:/ms4w/apache/htdocs/i3geo";
	/*
	Variable: temasdir
	
	Caminho completo do diretrio onde ficam os arquivos .map correspondentes aos temas disponveis
	Esta varivel no est implementada completamente. Os mapfiles devem ficar obrigatoriamente no diretrio temas
	
	Tipo:
	{string}
	*/
	$temasdir = $locaplic."/temas"; //"c:/ms4w/apache/htdocs/i3geo/temas";
	/*
	Variable: temasaplic
	
	Caminho completo onde ficam os arquivos .map especficos do I3Geo
	
	Tipo:
	{string}
	*/
	$temasaplic = $locaplic."/aplicmap";//"c:\ms4w\apache\htdocs\i3geo\aplicmap";
	/*
	Variable: locmapserv
	
	Localizao do executvel do Mapserver conforme deve ser acrescentado a URL aps o nome do host.
	
	Essa varivel  necessria em processos que utilizam o mapserver no modo CGI.
	
	Por exemplo, se o endereo for http://localhost/cgi-bin/mapserv.exe, a varivel dever conter apenas /cgi-bin/mapserv.exe
	
	Tipo:
	{string}
	*/
	$locmapserv = "/cgi-bin/mapserv.exe";
	/*
	Variable: locsistemas
	
	Onde fica o xml que ser utilizado para complementar a lista de temas disponveis na rvore de adio de temas.
	
	Se for "" ser utilizado o sistema de administrao do i3geo (veja i3geo/admin).
	
	Com base no arquivo xml  montada uma rvore de opes que  adicionada  arvore de temas mostrada na guia "Adiciona" do i3geo.
	
	Por meio dessa nova rvore pode-se disparar programas PHP que executam operaes especiais para a montagem de uma nova camada a ser adicionada ao mapa.
	
	Veja a documentao especfica do arquivo sistemas.xml para maiores detalhes.
	
	Tipo:
	{string}
	*/
	$locsistemas = "";
	/*
	Variable: locidentifica 
	
	Onde fica o xml que ser utilizado para complementar a lista de temas dispponveis na ferramenta de identificao.
	
	Se for "" ser utilizado o sistema de administrao do i3geo (veja i3geo/admin).		
	
	Com base no arquivo xml  montada uma lista de opes que  adicionada  lista de temas mostrada ferramenta de identificao de elementos no mapa.
	
	Por meio dessa lista pode-se disparar programas PHP que executam operaes especiais para a obteno de dados com base em um par de coordenadas xy.
	
	Veja a documentao especfica do arquivo identifica.xml para maiores detalhes.
	
	Tipo:
	{string}
	*/
	$locidentifica = "";
	/*
	Variable: locmapas 
	
	Onde fica o xml, para preencher a guia mapas.
	
	Se for "" ser utilizado o sistema de administrao do i3geo (veja i3geo/admin).	
	
	A guia "Mapas" mostra uma lista de links que permitem abrir mapas especficos. Essa lista  utilizada tambm pela verso mobile do i3geo.
	
	Veja a documentao especfica do arquivo mapas.xml para maiores detalhes.
	
	Tipo:
	{string}
	*/
	$locmapas = "";
	/*
	Variable: R_path
	
	Onde esta o executavel do software R
	
	O R  um pacote estatstico utilizado pelo I3Geo para gerao de grficos e anlises estatsticas
	Se vc no possui o R instalado, comente a linha abaixo
	
	Tipo:
	{string}
	*/
	$R_path = "c:/r/win/bin/R.exe";
	/*
	Depreciado - no  mais necessrio na verso 5.x do Mapserver
	string de conexo com o banco de dados postgis utilizada para reallizao de clculos
	se no existir, deixe em branco
	*/
	$postgis_con = "";
	/*
	Depreciado - no  mais necessrio na verso 5.x do Mapserver
	srid utilizado nos clculos que exigem projeo equivalente
	*/
	$srid_area = 1;
	/*
	Variable: postgis_mapa
	
	String de conexo para acesso aos dados (opcional).
	
	Com o uso opcional dessa varivel  possvel esconder a string de conexo com o banco de dados. O Mapserver
	no permite esconder essa string, por isso, no i3geo, foi implementado um esquema de substituio.
	Toda vez que um objeto "map"  criado via PHP Mapscript, a string de conexo  substituda de " " para o valor de $postgis_mapa.
	Se no for desejado a substituio, deixe essa varivel em branco.
	Se vc especificar essa varivel, o mapa ser forado a recusar o modo de operao CGI.
	
	Para mais detalhes veja a funo substituiCon em classesphp/funcoes_gerais.php
	
	Importante - se vc usar o modo de substituio de strings, as interfaces que dependem do modo CGI
	para funcionarem, no sero capazes de acessar os dados. Isso afeta por exemplo, a interface Google Maps e Openlayers.
	
	exemplo - 
	
	$postgis_mapa = array(
		"conexao1"=>"user=geodados password=geodados dbname=geodados host=10.1.1.36 port=5432",
		"conexao2"=>"user=geodados password=geodados dbname=geodadosteste host=10.1.1.36 port=5432"
	)
	
	Tipo:
	{array ou  string}
	*/
	$postgis_mapa = array("teste"=>"user=postgres password=postgres dbname=pgutf8 host=localhost port=5432 options='-c client_encoding=LATIN1'"); //"user=geodados password=geodados dbname=geodados host=10.1.1.36 port=5432";
	/*
	Variable: menutemas
	
	Array com a lista de arquivos xml que sero incluidos na guia de adio de temas. Se for "", ser utilizado o arquivo default menutemas/menutemas.xml.
	
	Esse xml define a lista de temas que sero mostrados na guia "Adiciona".
	
	Para mais detalhes veja a documentao especfica do arquivo menutemas/menutemas.xml
	
	Utilize o caminho completo no servidor para o nome dos wml, assim vc evita problemas em servios do tipo kml e ogc
	
	Example:

	$menutemas = array(
		array("publicado"=>"sim","idmenu"=>"A","arquivo"=>"http://localhost/i3geo/menutemas/geopr.xml","status"=>"fechado"),
		array("publicado"=>"sim","idmenu"=>"B","arquivo"=>"http://localhost/i3geo/menutemas/menutemas.xml","status"=>"aberto")
		);

		
	Para usar o menu default, utilize apenas $menutemas = ""; nesse caso, os menus sero obtidos do 
	banco de dados de administrao. Para editar o banco de dados utilize http://localhost/i3geo/admin
	
	Tipo:
	{string}
	*/
	$menutemas = "";
	/*
	Variable: utilizacgi
	
	Varivel indicando se o desenho do corpo do mapa ser baseado no modo cgi.
	
	Por default, o mapserver desenha o mapa via php, porm, pode-se alterar o modo de desenho.
	
	No modo normal, a imagem do mapa  gerada e armazenada no diretrio ms_tmp. Aps a gerao da imagem 
	o endereo do arquivo  retornado ao mapa (retorno via Ajax) e o javascript se encarrega de alterar o
	endereo da imagem no navegador. Com o uso do CGI a imagem no  gerada, sendo repassado ao navegador
	o endereo do cgi acrescentado do nome do mapfile, fazendo com que a imagem seja retornada diretamente.
	
	Em alguns casos o uso do cgi torna a aplicao mais rpida.
	
	Tipo:
	{string}
	*/
	$utilizacgi = "nao";
	/*
	 Variable: atlasxml
	 
	 Indica o nome do arquivo xml que ser utilizado na interface Atlas do i3geo.
	 
	 Pode ser utilizado o caminho relativo, tendo como base i3geo/diretorio
	 
	 Tipo:
	 {string}
	*/
	$atlasxml = "";
	/*
	 Variable: expoeMapfile
	 
	 Essa varivel controla se o nome do mapfile atual ser ou no retornado para a aplicao via ajax.
	 
	 Quando essa varivel for definida como "nao" algumas das funcionalidades do i3geo podero ficar prejudicadas, mas sem comprometimento das funes principais.
	 
	 Tipo:
	 {string}
	*/
	$expoeMapfile = "sim";
	/*
	 Variable: conexaoadmin
	 
	 Arquivo PHP que define a string de conexo (PDO) com o banco de dados administrativo.
	 
	 Esse arquivo  includo no programa i3geo/admin/conexao.php
	 
	 O banco de dados administrativo  utilizado para definir coisas como a rvore de temas, rvore de mapas, etc.
	 
	 O banco de dados, originalmente,  montado em SQLITE, porm, em ambientes corporativos, sugere-se o uso de bancos de daods mais robustos.
	 
	 Se voc quiser utilizar a conexo default, baseado no SQLITE, mantenha essa varivel vazia.
	 
	 O uso do banco de dados no  obrigatrio, uma vez que os arquivos podem ser mantidos em disco (arquivos XML).
	
	 O programa PHP que estabelece a conexo deve retornar objetos com nomes padronizados. Veja o arquivo i3geo/admin/conexao.php para maiores detalhes.
	
	 Exemplos:
	 
	 $conexaoadmin = $locaplic."/admin/php/conexaopostgresql.php";
	 $conexaoadmin = $locaplic."/admin/php/conexaomma.php";
	
	Tipo:
	{string}
	*/
	$conexaoadmin = "";
	/*
	 Variable: interfacePadrao
	 
	 Interface padro utilizada para abrir o mapa.
	 
	 A interface pode ser um arquivo com as extenses .htm .html .phtml
	 
	 O arquivo deve estar armazenado em i3geo/aplicmap
	 
	 Tipo:
	 {string}
	*/
	$interfacePadrao = "geral.htm";
}
else //se for linux
{
	$editores = array("127.0.0.1","localhost");
	$dir_tmp = "/var/tmp/ms_tmp";
	$temasdir = "/opt/www/html/i3geo/temas";
	$temasaplic = "/opt/www/html/i3geo/aplicmap";
	$locmapserv = "/cgi-bin/mapserv";
	$locaplic = "/opt/www/html/i3geo";
	$locsistemas= "";//"http://dsvmapas.mma.gov.br/i3geo/menutemas/sistemas.xml";
	$locidentifica = "";//"http://dsvmapas.mma.gov.br/i3geo/menutemas/identifica.xml";
	$locmapas = "";//"http://dsvmapas.mma.gov.br/abremapa.php?id=xml";
	$R_path = "R";//se vc no instalou o R no seu servidor, tente o endereo $R_path = $locaplic."/pacotes/r/linux/r";
	$postgis_con = "";
	$srid_area = 1;
	$postgis_mapa = "";
	$menutemas = ""; 
	$utilizacgi = "nao";
	$atlasxml = "";//"../menutemas/atlas.xml";
	$expoeMapfile = "sim";
	$conexaoadmin = "";
	$interfacePadrao = "geral.htm";
}
?>
